"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var argumenter_1 = require("@joejukan/argumenter");
var web_kit_1 = require("@joejukan/web-kit");
var _1 = require("../.");
var VueDIPlugin = /** @class */ (function () {
    function VueDIPlugin() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var argue = new argumenter_1.Argumenter(args);
        this.options = argue.object;
    }
    VueDIPlugin.prototype.apply = function (compiler) {
        var _this = this;
        compiler.plugin('beforeCompile', function () {
            _this.log('beforeCompile');
            if (web_kit_1.access(_this, 'options.injections')) {
                var injections = _this.options.injections;
                for (var path in injections) {
                    var components = injections[path];
                    for (var symbol in components) {
                        var name_1 = web_kit_1.kebab(symbol);
                        _this.log("injecting component [ name: " + name_1 + ", symbol: " + symbol + ", module: " + path + " ]");
                        _1.dependencies[name_1] = new _1.DependencyClass(name_1, symbol, path, true);
                    }
                }
            }
        });
    };
    VueDIPlugin.prototype.log = function (value) {
        if (web_kit_1.access(this, 'options.debug')) {
            console.log("[vue-di-plugin]: " + value);
        }
    };
    return VueDIPlugin;
}());
exports.VueDIPlugin = VueDIPlugin;
//# sourceMappingURL=vue.di.plugin.js.map